#define SC_RESET	0xff
#define SC_RESEND	0xfe
#define SC_DEFAULT	0xf6
#define SC_DISABLE	0xf5
#define SC_ENABLE	0xf4
#define SC_SETYPEMATIC	0xf3
#define SC_ECHO		0xee
#define SC_MODE		0xed

#define SC_ACK		0xfa
#define SC_OVERRUN	0x00
#define SC_DIAGFAIURE	0xfd
#define SC_BREAK	0xf0
#define SC_BAT		0xaa


#define CC_LSHFT	0x2a
#define CC_RSHFT	0x36

#define CC_CTRL		0x1d
#define CC_ALT		0x38
#define CC_CAPS		0x3a

struct codetab {
	unsigned char	code;
	unsigned char	uchar;
	unsigned char	schar;
	unsigned char	cchar;
};

#ifdef UNIX
struct codetab codetab[] = {
/*00*/	 0xff,0xff,0xff,0xff,
/*01*/	 0x43,0xff,0xff,0xff,
/*02*/	 0x41,0xff,0xff,0xff,
/*03*/	 0x3f,0xff,0xff,0xff,
/*04*/	 0x3d,0xff,0xff,0xff,
/*05*/	 0x3b,0xff,0xff,0xff,
/*06*/	 0x3c,0xff,0xff,0xff,
/*07*/	 0xff,0xff,0xff,0xff,
/*08*/	 0xff,0xff,0xff,0xff,
/*09*/	 0x44,0xff,0xff,0xff,
/*0A*/	 0x42,0xff,0xff,0xff,
/*0B*/	 0x40,0xff,0xff,0xff,
/*0C*/	 0x3e,0xff,0xff,0xff,
/*0D*/	 0x0f,0xff,0xff,0xff,
/*0E*/	 0x29,0xff,0xff,0xff,
/*0F*/	 0xff,0xff,0xff,0xff,
/*10*/	 0xff,0xff,0xff,0xff,
/*11*/	 0x38,0xff,0xff,0xff,
/*12*/	 0x2a,0xff,0xff,0xff,
/*13*/	 0xff,0xff,0xff,0xff,
/*14*/	 0x1d,0xff,0xff,0xff,
/*15*/	 0x10,0xff,0xff,0xff,
/*16*/	 0x02,0xff,0xff,0xff,
/*17*/	 0xff,0xff,0xff,0xff,
/*18*/	 0xff,0xff,0xff,0xff,
/*19*/	 0xff,0xff,0xff,0xff,
/*1A*/	 0x2c,0xff,0xff,0xff,
/*1B*/	 0x1f,0xff,0xff,0xff,
/*1C*/	 0x1e,0xff,0xff,0xff,
/*1D*/	 0x11,0xff,0xff,0xff,
/*1E*/	 0x03,0xff,0xff,0xff,
/*1F*/	 0xff,0xff,0xff,0xff,
/*20*/	 0xff,0xff,0xff,0xff,
/*21*/	 0x2e,0xff,0xff,0xff,
/*22*/	 0x2d,0xff,0xff,0xff,
/*23*/	 0x20,0xff,0xff,0xff,
/*24*/	 0x12,0xff,0xff,0xff,
/*25*/	 0x05,0xff,0xff,0xff,
/*26*/	 0x04,0xff,0xff,0xff,
/*27*/	 0xff,0xff,0xff,0xff,
/*28*/	 0xff,0xff,0xff,0xff,
/*29*/	 0x39,0xff,0xff,0xff,
/*2A*/	 0x2f,0xff,0xff,0xff,
/*2B*/	 0x21,0xff,0xff,0xff,
/*2C*/	 0x14,0xff,0xff,0xff,
/*2D*/	 0x13,0xff,0xff,0xff,
/*2E*/	 0x06,0xff,0xff,0xff,
/*2F*/	 0xff,0xff,0xff,0xff,
/*30*/	 0xff,0xff,0xff,0xff,
/*31*/	 0x31,0xff,0xff,0xff,
/*32*/	 0x30,0xff,0xff,0xff,
/*33*/	 0x23,0xff,0xff,0xff,
/*34*/	 0x22,0xff,0xff,0xff,
/*35*/	 0x15,0xff,0xff,0xff,
/*36*/	 0x07,0xff,0xff,0xff,
/*37*/	 0xff,0xff,0xff,0xff,
/*38*/	 0xff,0xff,0xff,0xff,
/*39*/	 0xff,0xff,0xff,0xff,
/*3A*/	 0x32,0xff,0xff,0xff,
/*3B*/	 0x24,0xff,0xff,0xff,
/*3C*/	 0x16,0xff,0xff,0xff,
/*3D*/	 0x08,0xff,0xff,0xff,
/*3E*/	 0x09,0xff,0xff,0xff,
/*3F*/	 0xff,0xff,0xff,0xff,
/*40*/	 0xff,0xff,0xff,0xff,
/*41*/	 0x33,0xff,0xff,0xff,
/*42*/	 0x25,0xff,0xff,0xff,
/*43*/	 0x17,0xff,0xff,0xff,
/*44*/	 0x18,0xff,0xff,0xff,
/*45*/	 0x0b,0xff,0xff,0xff,
/*46*/	 0x0a,0xff,0xff,0xff,
/*47*/	 0xff,0xff,0xff,0xff,
/*48*/	 0xff,0xff,0xff,0xff,
/*49*/	 0x34,0xff,0xff,0xff,
/*4A*/	 0x35,0xff,0xff,0xff,
/*4B*/	 0x26,0xff,0xff,0xff,
/*4C*/	 0x27,0xff,0xff,0xff,
/*4D*/	 0x19,0xff,0xff,0xff,
/*4E*/	 0x0c,0xff,0xff,0xff,
/*4F*/	 0xff,0xff,0xff,0xff,
/*50*/	 0xff,0xff,0xff,0xff,
/*51*/	 0xff,0xff,0xff,0xff,
/*52*/	 0x28,0xff,0xff,0xff,
/*53*/	 0xff,0xff,0xff,0xff,
/*54*/	 0x1a,0xff,0xff,0xff,
/*55*/	 0x0d,0xff,0xff,0xff,
/*56*/	 0xff,0xff,0xff,0xff,
/*57*/	 0xff,0xff,0xff,0xff,
/*58*/	 0x3a,0xff,0xff,0xff,
/*59*/	 0x36,0xff,0xff,0xff,
/*5A*/	 0x1c,0xff,0xff,0xff,
/*5B*/	 0x1b,0xff,0xff,0xff,
/*5C*/	 0xff,0xff,0xff,0xff,
/*5D*/	 0x2b,0xff,0xff,0xff,
/*5E*/	 0xff,0xff,0xff,0xff,
/*5F*/	 0xff,0xff,0xff,0xff,
/*60*/	 0xff,0xff,0xff,0xff,
/*61*/	 0xff,0xff,0xff,0xff,
/*62*/	 0xff,0xff,0xff,0xff,
/*63*/	 0xff,0xff,0xff,0xff,
/*64*/	 0xff,0xff,0xff,0xff,
/*65*/	 0xff,0xff,0xff,0xff,
/*66*/	 0x0e,0xff,0xff,0xff,
/*67*/	 0xff,0xff,0xff,0xff,
/*68*/	 0xff,0xff,0xff,0xff,
/*69*/	 0x4f,0xff,0xff,0xff,
/*6A*/	 0xff,0xff,0xff,0xff,
/*6B*/	 0x4b,0xff,0xff,0xff,
/*6C*/	 0x47,0xff,0xff,0xff,
/*6D*/	 0xff,0xff,0xff,0xff,
/*6E*/	 0xff,0xff,0xff,0xff,
/*6F*/	 0xff,0xff,0xff,0xff,
/*70*/	 0x52,0xff,0xff,0xff,
/*71*/	 0x53,0xff,0xff,0xff,
/*72*/	 0x50,0xff,0xff,0xff,
/*73*/	 0x4c,0xff,0xff,0xff,
/*74*/	 0x4d,0xff,0xff,0xff,
/*75*/	 0x48,0xff,0xff,0xff,
/*76*/	 0x01,0xff,0xff,0xff,
/*77*/	 0x45,0xff,0xff,0xff,
/*78*/	 0xff,0xff,0xff,0xff,
/*79*/	 0x4e,0xff,0xff,0xff,
/*7A*/	 0x51,0xff,0xff,0xff,
/*7B*/	 0x4a,0xff,0xff,0xff,
/*7C*/	 0x37,0xff,0xff,0xff,
/*7D*/	 0x49,0xff,0xff,0xff,
/*7E*/	 0x46,0xff,0xff,0xff,
/*7F*/	 0x54,0xff,0xff,0xff
};
#endif 
