/*
	Processor State information
	There are 2 
		one is for the monitor,
		the other for the run-time code.
*/
struct state {
/*0*/	unsigned long reg[15];	/* D0-D7,A0-A6 */
/*60*/	unsigned long usp;	/* A7 S=0 */
/*64*/	unsigned long ssp;	/* A7' S=1,M=0, same as A7' */
/*68*/	unsigned long msp;	/* A7'' S=1,M=1, same as A7'' */
/*72*/	unsigned long pc;	/* program counter */
/*76*/	unsigned short sr;	/* status register */
/*78*/	unsigned char sfc,dfc;	/* alternate function code registers */
/*80*/	unsigned long vbr;	/* vector base register */
/*84*/	unsigned long cacr;	/* cache control register */
/*88*/	unsigned long caar;	/* cache address register */
/*92*/	unsigned long crp[2];	/* cpu root pointer */
/*100*/	unsigned long srp[2];	/* supervisory root pointer */
/*108*/	unsigned long tc;	/* translation control */
/*112*/	unsigned long tt0;	/* transparent translation */
/*116*/	unsigned long tt1;	/* transparent translation */
/*120*/	unsigned long mmusr;	/* mmu status register */
/*124*/	unsigned short vector;	/* vector/frame type */
	unsigned short binstr;	/* instruction at breakpoint */
/*128*/ unsigned long trace;	/* how many trace cycles are left */
	unsigned long baddr;	/* address of breakpoint */
};
